package com.dayou.service.impl;

import com.dayou.entity.OrderFund;
import com.dayou.mapper.OrderFundMapper;
import com.dayou.service.IOrderFundService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dayou.utils.ExcelUtil;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.web.multipart.MultipartFile;

import java.math.BigDecimal;
import java.util.List;
import java.util.ArrayList;
import org.springframework.transaction.annotation.Transactional;
import com.dayou.enums.BatchTaskTypeEnum;

/**
 * <p>
 * 订单应收款 服务实现类
 * </p>
 *
 * @author wucl
 * @since 2023-12-14
 */
@Service
public class OrderFundServiceImpl extends ServiceImpl<OrderFundMapper, OrderFund> implements IOrderFundService {

    @Autowired
    private OrderFundMapper orderFundMapper;

    @Override
    @SuppressWarnings("unchecked")
    public Page<OrderFund> selectPage(Page page,OrderFund orderFund){
        return this.page(page, new QueryWrapper<OrderFund>(orderFund));
    }


    @Override
    public OrderFund detail(Long id){
        return this.getById(id);
    }

    @Override
    public Boolean add(OrderFund orderFund){
        return  this.save(orderFund);
    }

    @Override
    public Boolean update(OrderFund orderFund){
        return  this.updateById(orderFund);
    }

    @Override
    public Boolean delete(Long id){
        //逻辑删除
        return this.removeById(id);
    }

    @Override
    public synchronized BigDecimal residueNotAllotAmount(Long orderFundId) {
        BigDecimal residue = orderFundMapper.residueNotAllotAmount(orderFundId);
        return residue;
    }
}
